use std::ops::{Add, AddAssign, DivAssign, Sub, SubAssign};

use num::*;

mod coordinate_systems;
pub mod strings;
pub use advent_of_code_macros::*;
pub use coordinate_systems::*;

pub type Table = Vec<Vec<char>>;

pub fn matrix(zero: bool, diag: bool, non_diag: bool) -> Vec<(i32, i32)> {
    const MIN: i32 = -1;
    const MAX: i32 = 1;
    let mut d = Vec::new();
    for i in MIN..=MAX {
        for j in MIN..=MAX {
            let ia = i.abs();
            let ja = j.abs();
            if zero && i == 0 && j == 0 {
                d.push((i, j));
            }
            if diag && ia == 1 && ja == 1 {
                d.push((i, j));
            }
            if non_diag && ia != ja && ia + ja == 1 {
                d.push((i, j));
            }
        }
    }
    d
}

pub fn numberlength<T: Integer + DivAssign + From<u32> + Copy>(n: T) -> u32 {
    let divider = T::from(10);
    let mut num = n;
    let mut length = 0;
    loop {
        if num < divider {
            return length + 1;
        }
        num /= divider;
        length += 1;
    }
}
